
#include "main.h"
#include "chaos.h"

///::title:: Dambreak with random high water level and bottom topography (2D version)
///::vars:: NX=128 NY=128 MAXT=0.1 BED_OFFSET=1.0
///::consts:: MAXX=2 MAXY=2 N_UNIFORM=3 N_NORMAL=0
///::macro:: SOURCE_HOOK topography.h compute_source(i,j);
///::depends:: topography_flat2d-random
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  if (x < 1.0)
    v.h = 2.0 + 0.1*w.uniform[0];
  else
    v.h = 1.5;
  v.h -= b(x,y);
}
