
#include "equation.h"
#include "chaos.h"

///::title:: Sod shock tube
///::vars:: NX=512
///::consts:: MAXX=2.0 MAXT=0.1
///::consts:: N_UNIFORM=1 N_NORMAL=0
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  
  x *= pi;
  
  real epsilon = 0.5 * w.uniform[0];
  real freq    = 50;
  
  v.rho = 1.0;
  v.u[X] = 1.0 - 0.5*sin(x) + epsilon*sin(freq*x);
  v.p = 1.0;
}
