
#include "main.h"

// Powell Source, First Order

#if !NO_POWELL

void powell_source(vector &us, vector &Bs, AllVariables &lV, AllVariables &rV,
		   int i, int j, int k, int d)
{
  real dB = (rV.U.B[d] - lV.U.B[d])/dx[d];
  real dB2 = 0.5*(rV.U.B[d]*rV.U.B[d] - lV.U.B[d]*lV.U.B[d])/dx[d];
  Bs[d] = 0;
  real uBB = us[d]*dB2 + (us*Bs)*dB;
  ConservedVars *S;

  if (us[d] >= 0) {
    S = &(Source[i][j][k]);
  } else {
    S = &(Source[i-DX[d]][j-DY[d]][k-DZ[d]]);
  }
  S->m -= Bs*dB;
  S->m[d] -= dB2;
  S->E -= uBB;
  S->B -= us*dB;
}

#endif
