
#include "main.h"
#include "space.h"

///::title:: Second Order in Space, plain MINMOD
///::depends:: time_o2 substep_o12 powell_o23
///::consts:: GHOST_SIZE=2 ORDER=2
///::vars:: CFL=0.475

// !!! implemented for scalar 1-D only !!!

real minmod (real a, real b) {
  if (sign(a) == sign(b))
    return min(fabs(a), fabs(b));
  else
    return 0.0;
}

void left(AllVariables &V, int i, int j, int k, int d)
{
  real slopeDX = minmod(U[i][j][k].u - U[i-1][j][k].u, U[i+1][j][k].u - U[i][j][k].u);
  V.U.u = U[i][j][k].u - slopeDX/2.0;
  calc_xtra(V.XU, V.U, i, j, k);
}

void right(AllVariables &V, int i, int j, int k, int d)
{
  real slopeDX = minmod(U[i][j][k].u - U[i-1][j][k].u, U[i+1][j][k].u - U[i][j][k].u);
  V.U.u = U[i][j][k].u + slopeDX/2.0;
  calc_xtra(V.XU, V.U, i, j, k);
}