
#include "topography.h"

#include "equation.h"
#include "multi.h"
#include "chaos.h"

#define HEIGHT 0.3
#define WIDTH 0.2
#define CENTER 1.0
#define PERTURBATION 0.1

// parabolic "bump" centered at CENTER, with given HEIGHT and width being 2*WIDTH is perturbed with +/- PERTURBATION

real b (real x, real y) {
  real height = HEIGHT + PERTURBATION * (1 - 2*w.uniform[1]);
  return BED_OFFSET + ( fabs(x-CENTER) < WIDTH ? height - sqr(x-CENTER)*(height / sqr(WIDTH)) : 0.0 );
}
